/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ConversationMessageDataTemplate type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ConversationMessageDataTemplate{}

// ConversationMessageDataTemplate struct for ConversationMessageDataTemplate
type ConversationMessageDataTemplate struct {
	Type TemplateType `json:"type"`
	Internal *InternalTemplate `json:"internal,omitempty"`
	// The map of any string values used for cutom external references. 
	InternalComponents *map[string]string `json:"internal_components,omitempty"`
	Whatsapp *WhatsAppTemplate `json:"whatsapp,omitempty"`
	WhatsappComponents []WhatsAppTemplateMessageComponent `json:"whatsapp_components,omitempty"`
}

// NewConversationMessageDataTemplate instantiates a new ConversationMessageDataTemplate object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewConversationMessageDataTemplate(type_ TemplateType) *ConversationMessageDataTemplate {
	this := ConversationMessageDataTemplate{}
	this.Type = type_
	return &this
}

// NewConversationMessageDataTemplateWithDefaults instantiates a new ConversationMessageDataTemplate object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewConversationMessageDataTemplateWithDefaults() *ConversationMessageDataTemplate {
	this := ConversationMessageDataTemplate{}
	return &this
}

// GetType returns the Type field value
func (o *ConversationMessageDataTemplate) GetType() TemplateType {
	if o == nil {
		var ret TemplateType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *ConversationMessageDataTemplate) GetTypeOk() (*TemplateType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *ConversationMessageDataTemplate) SetType(v TemplateType) {
	o.Type = v
}

// GetInternal returns the Internal field value if set, zero value otherwise.
func (o *ConversationMessageDataTemplate) GetInternal() InternalTemplate {
	if o == nil || IsNil(o.Internal) {
		var ret InternalTemplate
		return ret
	}
	return *o.Internal
}

// GetInternalOk returns a tuple with the Internal field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageDataTemplate) GetInternalOk() (*InternalTemplate, bool) {
	if o == nil || IsNil(o.Internal) {
		return nil, false
	}
	return o.Internal, true
}

// HasInternal returns a boolean if a field has been set.
func (o *ConversationMessageDataTemplate) HasInternal() bool {
	if o != nil && !IsNil(o.Internal) {
		return true
	}

	return false
}

// SetInternal gets a reference to the given InternalTemplate and assigns it to the Internal field.
func (o *ConversationMessageDataTemplate) SetInternal(v InternalTemplate) {
	o.Internal = &v
}

// GetInternalComponents returns the InternalComponents field value if set, zero value otherwise.
func (o *ConversationMessageDataTemplate) GetInternalComponents() map[string]string {
	if o == nil || IsNil(o.InternalComponents) {
		var ret map[string]string
		return ret
	}
	return *o.InternalComponents
}

// GetInternalComponentsOk returns a tuple with the InternalComponents field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageDataTemplate) GetInternalComponentsOk() (*map[string]string, bool) {
	if o == nil || IsNil(o.InternalComponents) {
		return nil, false
	}
	return o.InternalComponents, true
}

// HasInternalComponents returns a boolean if a field has been set.
func (o *ConversationMessageDataTemplate) HasInternalComponents() bool {
	if o != nil && !IsNil(o.InternalComponents) {
		return true
	}

	return false
}

// SetInternalComponents gets a reference to the given map[string]string and assigns it to the InternalComponents field.
func (o *ConversationMessageDataTemplate) SetInternalComponents(v map[string]string) {
	o.InternalComponents = &v
}

// GetWhatsapp returns the Whatsapp field value if set, zero value otherwise.
func (o *ConversationMessageDataTemplate) GetWhatsapp() WhatsAppTemplate {
	if o == nil || IsNil(o.Whatsapp) {
		var ret WhatsAppTemplate
		return ret
	}
	return *o.Whatsapp
}

// GetWhatsappOk returns a tuple with the Whatsapp field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageDataTemplate) GetWhatsappOk() (*WhatsAppTemplate, bool) {
	if o == nil || IsNil(o.Whatsapp) {
		return nil, false
	}
	return o.Whatsapp, true
}

// HasWhatsapp returns a boolean if a field has been set.
func (o *ConversationMessageDataTemplate) HasWhatsapp() bool {
	if o != nil && !IsNil(o.Whatsapp) {
		return true
	}

	return false
}

// SetWhatsapp gets a reference to the given WhatsAppTemplate and assigns it to the Whatsapp field.
func (o *ConversationMessageDataTemplate) SetWhatsapp(v WhatsAppTemplate) {
	o.Whatsapp = &v
}

// GetWhatsappComponents returns the WhatsappComponents field value if set, zero value otherwise.
func (o *ConversationMessageDataTemplate) GetWhatsappComponents() []WhatsAppTemplateMessageComponent {
	if o == nil || IsNil(o.WhatsappComponents) {
		var ret []WhatsAppTemplateMessageComponent
		return ret
	}
	return o.WhatsappComponents
}

// GetWhatsappComponentsOk returns a tuple with the WhatsappComponents field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageDataTemplate) GetWhatsappComponentsOk() ([]WhatsAppTemplateMessageComponent, bool) {
	if o == nil || IsNil(o.WhatsappComponents) {
		return nil, false
	}
	return o.WhatsappComponents, true
}

// HasWhatsappComponents returns a boolean if a field has been set.
func (o *ConversationMessageDataTemplate) HasWhatsappComponents() bool {
	if o != nil && !IsNil(o.WhatsappComponents) {
		return true
	}

	return false
}

// SetWhatsappComponents gets a reference to the given []WhatsAppTemplateMessageComponent and assigns it to the WhatsappComponents field.
func (o *ConversationMessageDataTemplate) SetWhatsappComponents(v []WhatsAppTemplateMessageComponent) {
	o.WhatsappComponents = v
}

func (o ConversationMessageDataTemplate) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ConversationMessageDataTemplate) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["type"] = o.Type
	if !IsNil(o.Internal) {
		toSerialize["internal"] = o.Internal
	}
	if !IsNil(o.InternalComponents) {
		toSerialize["internal_components"] = o.InternalComponents
	}
	if !IsNil(o.Whatsapp) {
		toSerialize["whatsapp"] = o.Whatsapp
	}
	if !IsNil(o.WhatsappComponents) {
		toSerialize["whatsapp_components"] = o.WhatsappComponents
	}
	return toSerialize, nil
}

type NullableConversationMessageDataTemplate struct {
	value *ConversationMessageDataTemplate
	isSet bool
}

func (v NullableConversationMessageDataTemplate) Get() *ConversationMessageDataTemplate {
	return v.value
}

func (v *NullableConversationMessageDataTemplate) Set(val *ConversationMessageDataTemplate) {
	v.value = val
	v.isSet = true
}

func (v NullableConversationMessageDataTemplate) IsSet() bool {
	return v.isSet
}

func (v *NullableConversationMessageDataTemplate) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableConversationMessageDataTemplate(val *ConversationMessageDataTemplate) *NullableConversationMessageDataTemplate {
	return &NullableConversationMessageDataTemplate{value: val, isSet: true}
}

func (v NullableConversationMessageDataTemplate) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableConversationMessageDataTemplate) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


